<form method="POST" id="form_form" class="card-content">

    <div class="card-header">
        <button type="submit" name="form_filters_save" class="btn-unstyled record-btn">
            <img src="{{ url_for('static', filename='img/floppy-disk-solid.svg') }}" />
        </button>
        <!-- TO VERIFY -->
        <label class="card-title"
                {% if user_records.forms.active == 0 %}
                    for="form_filters_input"
                {% else %}
                    for="form_input"
                {% endif %}>Form Filters</label>
        <!-- --------- -->
        <button type="submit" name="form_filters_help" class="btn-unstyled record-btn wip" title="Tutorial is currently WIP for this widget">
            <img src="{{ url_for('static', filename='img/circle-question-solid.svg') }}" />
        </button>
    </div>

    <!-- Add & Remove Filter -->
    <div class="card-btn-row card-btn-seg10">
        <button type="submit" name="form_filter_add"
                class="btn-unstyled card-btn card-btn-mini card-btn-sub50">
            Add filter
        </button>
        <button type="submit" name="form_filter_remove"
                class="btn-unstyled card-btn card-btn-mini card-btn-sub50">
            Remove filter
        </button>
    </div>

    <!-- Filters by index & active filter -->
    <div class="card-btn-row card-btn-seg10"
        {% if user_records.forms.content.__len__() == 1 %}style="justify-content: center;"
        {% elif user_records.forms.content.__len__() == 2 %}style="justify-content: space-around;"
        {% endif %}>
        {% for form_filter in user_records.forms.content %}
            <button type="submit" name="form_filter_select_index" value="{{ form_filter.index }}"
                    class="btn-unstyled card-btn card-btn-mini card-btn-sub10
                        {% if user_records.forms.active == form_filter.index %} card-btn-active{% endif %}">
                {{ form_filter.index }}
            </button>
        {% endfor %}
    </div>

    <!-- New Form (row 1) & Active Form Filter options (add buttons) -->
    <!-- NB: alt versions: 1/ CONTAINS = 'ALL', card-btn-sub30 ; 2/ × = ✕✖╳⨉× -->
    <div class="card-btn-row card-btn-seg20
                {% if not user_records.forms.new_form %}card-widget{% endif %}">

        <!-- Add Form to active filter (FormID & EditorID buttons) -->
        {% if user_records.forms.active != 0 and not user_records.forms.new_form %}

            <div class="card-btn-row card-btn-seg10" style="margin-top: auto; margin-bottom: auto;">
                <p class="card-input-title">ADD :</p>
                {% for id_type in RecordIdType %}
                    <button type="submit" name="form_type_input" value="{{ id_type.name }}"
                            class="btn-unstyled card-btn card-btn-mini card-btn-sub40">
                        {{ id_type.name }}
                    </button>
                {% endfor %}
            </div>

        <!-- New Form inputs (for FormIDs & EditorIDs) -->
        {% elif user_records.forms.active != 0 and user_records.forms.new_form %}
            
            <!-- Mod name input (for FormIDs) -->
            {% if user_records.forms.new_form.id_type == RecordIdType['FormID'] %}
                <input type="text" id="mod_input" class="card-input card-input-mini card-input-mini-left" name="mod_input" placeholder="Mod name (with ext.)" onfocus="this.select()" value="{{ user_records.forms.new_form.mod }}">

            <!-- Wildcard pattern button (for EditorIDs) -->
            {% elif user_records.forms.new_form.id_type == RecordIdType['EditorID'] %}
                <div class="card-btn-row card-btn-seg10" style="width: 160px; display: flex; justify-content: center; margin-top: auto; margin-bottom: auto;">
                    <button type="submit" name="form_item_include"
                            class="btn-unstyled card-btn card-btn-mini card-btn-sub50
                                {% if user_records.forms.new_form.pattern == '*' %} card-btn-active{% endif %}">
                        CONTAINS
                    </button>
                </div>
            {% endif %}

            <!-- Back to Active Filter button (for FormIDs & EditorIDs) -->
            <button type="submit" name="back_to_filter" value="{{ user_records.forms.active }}"
                    class="btn-unstyled card-btn card-btn-mini card-btn-sub20 card-btn-trigger"
                    style="height:25px; width: 25px; margin-top: auto; margin-bottom: auto; font-size: 15px;">
                ×
            </button>
            
        {% endif %}
    </div>

    <!-- Full Form Filters & Active Form Filter (full text input) & New Form (row 2) -->
    <div class="card-btn-row card-btn-seg20">

        <!-- Full Form Filters (full text input) -->
        {% if user_records.forms.active == 0 %}
            <input type="text" id="form_filters_input" class="card-input" name="form_filters_input" placeholder="Form filters" onfocus="this.select()" value="{{ user_records.forms._get_value() }}">

        {% else %}

            <!--  New Form input - RecordID input (for FormIDs & EditorIDs) -->
            {% if user_records.forms.new_form %}
                <input type="text" id="id_input" class="card-input card-input-mini card-input-mini-left" name="id_input" placeholder="RecordID" onfocus="this.select()"
                    {% if user_records.forms.new_form.id_type == RecordIdType['FormID'] %}
                        value="{{ user_records.forms.new_form.form_id.value }}"
                    {% elif user_records.forms.new_form.id_type == RecordIdType['EditorID'] %}
                        value="{{ user_records.forms.new_form.editor_id }}"
                    {% endif %}>

                <!-- Add Form to Active Filter button (for FormIDs & EditorIDs) -->
                <button type="submit" name="add_form_to_filter" value="{{ user_records.forms.active }}"
                        class="btn-unstyled card-btn card-btn-mini card-btn-sub20 card-btn-trigger"
                        style="height:25px; width: 25px; margin-top: auto; margin-bottom: auto;">
                    +
                </button>

            <!-- Active Form Filter (full text input) -->
            {% else %}

                <!-- Exclusion pattern button (for active Form Filter) -->
                <button type="submit" name="form_filter_exclude"
                        class="btn-unstyled card-btn card-btn-mini card-btn-sub30
                            {% if user_records.forms.active > 0 and user_records.forms.content[user_records.forms.active - 1].pattern == '-' %} card-btn-active{% endif %}">
                    NOT
                </button>

                <!-- Full text input (for active Form Filter) -->
                <input type="text" id="form_input" class="card-input card-input-mini card-input-mini-right" name="form_filter_input" placeholder="Active filter" onfocus="this.select()" value="{{ user_records.forms.content[user_records.forms.active - 1]._get_value() }}">

            {% endif %}

        {% endif %}

    </div>

</form>



<!-- ---------- NOTES ----------

Form Filters
FormIDs/EditorIDs of specific forms used by actors, like factions/race/class (eg. 0x12345 or MyRecordEditorID).

0x1BCC0~test.esp
;this has a 50% chance to add a perk from test.esp to all NPCs from Test faction
Perk = 0x9DE80~test.esp|NONE|0x1BCC0~test.esp|NONE|NONE|NONE|50

List of valid filter form types
Faction
Class
CombatStyle
Race
Outfit
NPC
Spell
VoiceType
FormList
Editor Location

Multiple entries should be separated using a comma.
Mod added filter formIDs are supported (0x101~MyFactionMod.esp,0x223~MyRaceMod.esl)
EditorIDs can now be used in place of formIDs.

Pattern Matching
Requirements [strings, formIDs] - require actor to have all keywords or filter forms, using + (eg. ActorTypeGhost+ActorTypeAnimal to get animal ghosts).
Exclusions [strings, formIDs] - exclude actors that have name/keyword/form, using - (eg. -Serana).
Wildcards [strings] - find all actors that have name, editorID or keyword containing wildcard, using * (eg. *Draugr to get Draugr/Draugr Death Lord/Draugr Mage).
Matches [strings, formIDs] - this is default setting. NPC has to match with any filter.
These are evaluated in the following order :
1.Requirements
2.Exclusions
3.Matches
3.Wildcards -->
